#include <bits/stdc++.h>

using namespace std;

vector <vector <int>> ftree(vector <int> v, int n) {
    vector <vector <int>> sum(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (i == j) sum[i][j] = v[i];
            else sum[i][j] = sum[i][j-1] + v[j];
        }
    }
    return sum;
}

int main() {
    int n, k;
    cin >> n >> k;
    vector <int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector <vector <int>> tree(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (i == j) tree[i][j] = v[i];
            else tree[i][j] = tree[i][j-1] + v[j];
        }
    }
    int max_razn = 0;
    int len = n - k + 1;
    if (k == 2) {
        for (int i = 0; i < n - 1; i++) {
            max_razn = max(max_razn, abs(tree[0][i] - tree[i+1][n-1]));
        }
    }
    else {
    for (int i = 0; i < k; i++) {
        int summax = tree[i][i + len - 1];
        int summin = summax;
        for (int j = 0; j < i; j++) {
            summin = min(summin, v[j]);
        }
        for (int j = i+len; j < n; j++) {
            summin = min(summin, v[j]);
        }
        max_razn = max(summax - summin, max_razn);
        int sumotr = 0;
        for (int j = i; j < i + len ; j++) {
            sumotr = sumotr + v[j];
            if (summax - sumotr - v[j]> max_razn) max_razn = summax - sumotr - v[j];
        }
        sumotr = 0;
        for (int j = i + len - 1; j >= i; j--) {
            sumotr = sumotr + v[j];
            if (summax - sumotr - v[j]> max_razn) max_razn = summax - sumotr - v[j];
        }
    }
}
    cout << max_razn << endl;
}